unit Main;

//==================================================================================================================
// ROBOT DEMINEUR - Ouvrir, jouer, gagner au dmineur automatiquement
//
// Compatibilit : Windows 2000, XP
// Multilangues si paramtrage correcte  priori (non test)
//
// Pour Dfi wwW.Developpez.com section Delphi - Mai/Juin 2006
// Pseudo: TicTacToe
// Fil: http://www.developpez.net/forums/showthread.php?t=149995
//
// Merci  gRRosminet sur DVP pour son tutoriel sur les messages souris/clavier
// Merci  Waskol pour la couleur du 7 et sa grille bitmap pour dfinir le 7 :D
//==================================================================================================================
// DEFINITIONS
// Cellule vierge : cellule sans drapeaux, sans numro, encore indfinie
// Cellule numrote: Cellule contenant un numro (N4 = 4 mines autour)
// Ilot: c' est l'ensemble des cellules inter-dpendantes encore vierges
//       -> le changement d'tat (pose d'un drapeaux) d'une des cellules de l'ilot peut
//          influencer la cohrence de l'ensemble des cellules de l'ilot
// Cote: est l'ensemble des cellules numrotes bordant un ilot
// Solution d'ilot: Combinaison de drapeaux poss de manire cohrente sur un ilot entier
//
//NOTATIONS
// Le contenu des TStringList est dcrit par "[ string item, object ]" pour chaque lment
// Le contenu des TList est dcrit par "[ pointer ]"
//==================================================================================================================
// STRATEGIE GENERALE
//-------------------------------
// 1 TOUR DE CALCUL SE COMPOSE DE
//-------------------------------
//  - Lecture physique de l'tat du dmineur
//  - mise  jour de 'LGRille' et des Cellules associes  LGrille
//    - Etat des cellules
//    - Probabilit rapide de trouver une bombe (taux de 0  100%) par comptage lmentaire
//    -> Etablissement de la liste 'LAtraiter' des cellules vierges restantes, tries par taux
//  - Lecture de LAtraiter, plusieurs cas se prsentent:
//    - Aux extrmits de la liste, si des taux sont  0 ou 100%,
//      traitement des cellules (click gauche ou droit) et LE TOUR EST FINI
//    - SINON SI MODE 'Bete', on clique sur la 1ere cellule de la liste LAtraiter (taux faible) (*1)
//      puis TOUR FINI 
//    - SINON, SI MODE 'Reflexion', Cration des ilots de cellules inter-dpendantes
//      - Rsolution de toutes les solutions possibles par ilot
//      - 2 possiblits aprs ce traitement
//        - Des ilots contiennent des solutions UNIQUES, ON TRAITE -> TOUR FINI
//        - sinon, parmis les X solutions, comptage des drapeaux par cellule
//          - si aucun drapeaux n'apparait dans cellule -> DEMINE -> TOUR FINI
//          - si autant de drapeaux que de solutions dans cellule -> on pose le(s) drapeaux -> TOUR FINI
//          - sinon Mise  jour des taux / au nombres de drapeaux par cellule et redirection sur (*1)
//
// CONDITION D'ARRET des tours
//   - directement sur retour de click gauche -> si Etat = bombe = Perdu (BFIni = -1)
//   - si LATraiter.Count = 0 -> plus de cellule  traiter -> gagn (BFini = 1 )
//   - continuer tant que BFini (initialis  0) vaut 0 ...
//
// Rmq: LGrille contient l'ensemble des cellules de la grille [ ILigne, [ IColonne, TCellule] ]
// Rmq2: TCellule contient l'ensemble des paramtres d'une cellule (coord, taux, Etat...)
//
//==================================================================================================================
// INFOS LISTES COURAMMENT UTILISEES
// notation: TStringList[ string Item, Object]
//
// LATraiter : Liste des cellules vierges restantes  traiter - A jour aprs MajGrille
//             [ Taux, Coord ]
//
// LIlots : Listes des ilots actuellement dans la grille, LCelIlot est la liste des cellules de l'ilot
//          [ neant, LCelIlot ]
// LCelIlot : Liste des cellules d'un ilot - s'obtient  partir de LIlots
//            [ (compteur temporaire), Coord ]
// LCotes: Liste pour chaque iltot, des cellules de la cote numrote
//         [ nant, LCelCote ]
// LCelCote : Liste de cellules d'une cote - s'obtient  partir de LCotes
//            [ nant, Coord ]
//
// LIlotSolutions : Liste des solutions des diffrents ilots
//                  [ NIlot, LSolutions ]
// LSolutions : Listes des solutions d'un ilot
//              [ LDrapeaux ]
// LDrapeaux : Liste des drapeaux rsolus sur un ilot = UNE SOLUTION
//             S'obtient  partir de LIlotSolutions
//             [ indice sur LCelIlot ]
//
// rmq: les [coord] sont stockes sout la forme Y shl 16 + X
//==================================================================================================================
// AMELIORATIONS:
//   Optimisations nombreuses par adapation du code  l'algo gnral
//   Classe TIlot, pour synthtiser toutes les donnes d'un ilot... au lieu de multiple TxxxList
//   Classe TMaListe adapte aux listes utilise (taux dans une chaine formate 3car....)
//   Rentrer le nom du gagnant, mais c'est tellement + agrable de le rentrer manuellement ;)
//   faire une fonction pour les nombres 1ers....... le poil, le poil
//==================================================================================================================
//
// BLAH BLAH BLAH SUR LA RESOLUTION DES SOLUTIONS PAR ILOT.
//
// PREMIER ALGO TENTE - version beta5
//------------------------------------
// Etant donn que la notion d'ilot en mode rflexion a t tout de suite t introduite.
// La 1ere version du mode rflexion, utilisait
// un algorithme bas sur la recherche des diffrentes combinaisons de drapeaux
// sur un ilot (dans la ligne des ANP, que j'ai tent sur l'ilot et sur la cote).
// --> il me semble, 8 ou 9% de reussite en expert.
// --> AVANTAGE DE CET ALGO: IL est EXACT, et les stats dduites des diffrentes
// solutions le sont donc aussi -> donc approche la plus juste possible pour poser des drapeaux.
// --> DEFAUT (GROS): Dans le cas ou il y a beaucoup de cellules dans un ilot, le calcul
// des combinaisons devient prohibitif. -> on coupe alors l'algo au bout d'un
// certain temps, et cet ALGO devient alors INEXACTE, voir TRES INEXACTE.
// De plus, l'algo n'est pas simple  mettre en place (je ne veux pas de rcursivit)
// et de surcroit  optimiser.
//
// 2EME ALGO - ACTUEL, on compte sur du hasard control
//-----------------------------------------------------
//
// Puisque le temps de rsolution est trop long, il faut trouver une alternative
// afin de trouver un max de solutions pour un meme ilot dans un temps restreint
// Dans le but d'tablir des stats le + fiable possible pour chaque cellule, ou meme
// trouver des solutions unique par ilot dans le meilleur des cas.
// LE PROBLEME - comment ventiler les cellules vierges, poser des drapeaux et tester
// la cochrence le + rapidement possible sur un ilot donn?
//
// * 1ere Intuition - Parcours des cellules avec un certains incrment variable:
// Au 1er tour de solution - on prend 1 comme incrment, et on pose les drapeaux
// au fur et  mesure en restant coherent dans l'ilot. (on pose pas si depassement/cellule numrote)
// Au 2eme tour de solution - on prend 2 comme incrment ... etc...
// Pour viter Des parcours similaires, les nombres 1er m'ont sauts aux yeux
// comme la meilleure solution pour faire varier mon incrment.
// -> cela me permet de trouver env. 75% des solutions de manire trs rapide
//    et en tres peu d'itrations (50/80 est un max selon etude des journaux de stats en debug)
//
// * il reste des solutions  trouver qui n'ont pas t couvertes par la ventilation
// prcdente... l c'est le hasard qui prend le relais, en ventilant alatoirement
// toutes les cellules d'un ilot et en posant des drapeaux (tout en testant la cohrence
// bien sur de l'ilot).
// -> cela permet en fonction du nombre d'itrations de rcuprer pas mal de solutions
// restantes, probablement entre 15 et 20% (vraiment  vue de nez...).
// --> en combinant les 2 ventilations diffrentes, on trouve 90/95% des solutions
// de manire trs rapide. Tant pis pour le reste, si toutes les solutions n'y sont pas
// , statistiquement on s'y retrouve.
//
// ==> des solutions identiques peuvent tre trouves, un marquage unique par somme de nombres
// 1er m'a paru le + rapide afin de zapper et passer au tour suivant sans stocker  nouveau
// la solution trouve (sinon les taux de prsence de mine recalculs s'en trouvent faux).
// ==> Autre gros avantage de cette algo approximatif, on maitrise parfaitement le temps
// de calcul des solutions
//
// RMQ:
// ON pourrait combiner le 1ER ALGO et LE 2EME, mais finalement, lorsque le nbre de cellules
// d'un ilot est faible, la ventilation alatoire trouve souvent rellement toutes les solutions
// car le nbre d'itrations en mode alatoire n'est pas fonction du nombre de cellules d'un ilot
// et suffit par multiple balayage alatoire pour retrouver TOUTES les solutions
// Si le nombre de cellules dans un ilot est leve, on trouve pas moins de solution
// qu'un algo EXACT dans le mme temps, les parcours tant bcp plus simple et rapide.
//
//-----------------------------------------------------------
// RAPIDE CALCUL SUR UN ALGO PAR COMBINAISON, ANP typiquement
//-----------------------------------------------------------
// Un ilot possde 30 cellules (trs courant en mode expert), et autant sur la cote (souvent +)
// chaque cellules de la cotes,  x possibilit de poser un drapeau autour (1..8), moyenne 3 on va dire.
// --> le nombre d'itrations pour balayer toutes les combinaisons est donc 3^30 !!!
// bien qu'en affinant l'algo, on peut zapper trs vite sur certaines solutions -> ca reste considrable...
//
// APRES, Je suis sur, qu'il y a moyen de trouver un Algo EXACT pour trouver toutes
// les combinaisons d'un ilot de manire plus intelligente qu'en appliquant betement
// des combinaisons, mais il faut se prendre la tte un moment pour qu'il soit
// rapide !!! (division d'ilot au bon endroit, combinaison restreintes avec pose du 1er drapeaux
// sur chaque cellule et aprs on voit.. etc...)
//
//==================================================================================================================
// COMMENT UTILISER LE MODE DEBUG ?
// taper 'dvp' puis entre dans la zone 'nombre de parties', puis cliquer
// sur le logo bombe pour accder  l'cran DEBUG
//
//----------------------------------------
// MODE PAS A PAS - visu des constructions
//----------------------------------------
// 1. Lancer le dmineur manuellement avec 'Lancer Winmine'
// 2. tablir une grille sur dmineur:
//            - SOIT cliquer sur 'Jouer un tour'
//            - SOIT cliquer manuellement puis IMPERATIVEMENT cliquer sur 'MajGrille'
// 3. A tout moment, on peut crer et visualiser les ilots construits avec 'Creer et voir Ilot'
// 4. Cliquer sur 'ResoudreIlot' seulement si il y a eu creation d'ilot etape 3
//            -> le table adjacent prsente est la l'ensemble des solutions tout ilot confondu
//               il est sous la forme 'NIlot | Nbre de drapeaux de la solution'
//            -> cliquer sur une ligne, pour visualiser sur le dmineur la solution correspondante
// Rmq, 'Jouer un tour' agit selon l'algo prsent en 1er section '1 Tour'.
//
//--------------------------------------------------------
// ETUDE NBRE DE SOLUTIONS PAR NOMBRE DE CYCLE dans 1 tour
//--------------------------------------------------------
// Avant de lancer une srie de partie
//       -> cliquer sur 'INIT journal'
// Lancer la srie
// Aprs la srie de jeu, cliquer que 'COPIER Journal'
// CTRL-V Dans Excel
// On a pour les 3 cycles diffrents (expliqu dans ResoudreIlot)
// le nombre de solution pour chaque itration et pour chaque cycle
// --> on s'apercoit trs vite des %ages anoncs sur les solutions trouves.

//==================================================================================================================


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellAPI, ExtCtrls, Math, Clipbrd;

const
     // Nombres premiers - Pour identification des solutions et pour
     // gestion de parcours uniques
     NBPREM : array[ 0..479] of Integer = (
1, 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97,
101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197,
199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313,
317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439,
443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541,
547, 557, 563, 569, 571, 577, 587, 593, 599, 601, 607, 613, 617, 619, 631, 641, 643, 647, 653, 659,
661, 673, 677, 683, 691, 701, 709, 719, 727, 733, 739, 743, 751, 757, 761, 769, 773, 787, 797, 809,
811, 821, 823, 827, 829, 839, 853, 857, 859, 863, 877, 881, 883, 887, 907, 911, 919, 929, 937, 941,
947, 953, 967, 971, 977, 983, 991, 997, 1009, 1013, 1019, 1021, 1031, 1033, 1039, 1049, 1051, 1061, 1063,
1069, 1087, 1091, 1093, 1097, 1103, 1109, 1117, 1123, 1129, 1151, 1153, 1163, 1171, 1181, 1187, 1193, 1201,
1213, 1217, 1223, 1229, 1231, 1237, 1249, 1259, 1277, 1279, 1283, 1289,
1291, 1297, 1301, 1303, 1307, 1319, 1321, 1327, 1361, 1367, 1373, 1381, 1399, 1409, 1423, 1427, 1429, 1433,
1439, 1447, 1451, 1453, 1459, 1471, 1481, 1483, 1487, 1489, 1493, 1499, 1511, 1523, 1531, 1543, 1549, 1553,
1559, 1567, 1571, 1579, 1583, 1597, 1601, 1607, 1609, 1613, 1619, 1621, 1627, 1637, 1657, 1663, 1667, 1669,
1693, 1697, 1699, 1709, 1721, 1723, 1733, 1741, 1747, 1753, 1759, 1777, 1783, 1787, 1789, 1801, 1811, 1823,
1831, 1847, 1861, 1867, 1871, 1873, 1877, 1879, 1889, 1901, 1907, 1913, 1931, 1933, 1949, 1951, 1973, 1979,
1987, 1993, 1997, 1999, 2003, 2011, 2017, 2027, 2029, 2039, 2053, 2063, 2069, 2081, 2083, 2087,
2089, 2099, 2111, 2113, 2129, 2131, 2137, 2141, 2143, 2153, 2161, 2179, 2203, 2207, 2213, 2221, 2237, 2239,
2243, 2251, 2267, 2269, 2273, 2281, 2287, 2293, 2297, 2309, 2311, 2333, 2339, 2341, 2347, 2351, 2357, 2371,
2377, 2381, 2383, 2389, 2393, 2399, 2411, 2417, 2423, 2437, 2441, 2447, 2459, 2467, 2473, 2477, 2503, 2521,
2531, 2539, 2543, 2549, 2551, 2557, 2579, 2591, 2593, 2609, 2617, 2621, 2633, 2647, 2657, 2659, 2663, 2671,
2677, 2683, 2687, 2689, 2693, 2699, 2707, 2711, 2713, 2719, 2729, 2731, 2741,
2749, 2753, 2767, 2777, 2789, 2791, 2797, 2801, 2803, 2819, 2833, 2837, 2843, 2851, 2857, 2861, 2879, 2887,
2897, 2903, 2909, 2917, 2927, 2939, 2953, 2957, 2963, 2969, 2971, 2999, 3001, 3011, 3019, 3023, 3037, 3041,
3049, 3061, 3067, 3079, 3083, 3089, 3109, 3119, 3121, 3137, 3163, 3167, 3169, 3181, 3187, 3191, 3203, 3209,
3217, 3221, 3229, 3251, 3253, 3257, 3259, 3271, 3299, 3301, 3307, 3313, 3319, 3323, 3329, 3331, 3343, 3347,
3359, 3361, 3371, 3373, 3389, 3391, 3407 );



// Symbolique des tat cellules - utilisation de constantes au lieu num, car
// si l'tat > 0, c'est le numro de la cellule (Integer) qui est utilis en tant qu'Integer.
const
     ecVierge = 0;
     ecDeminee = -1;
     ecDrapeau = -2;
     ecPtInt = -3;
     ecBombe = -4;
     ecBombeM = -5;

// Dfinition des variables d'une cellule
type TCellule = class( TObject )
     public
       PPos: TPoint; // position dans la grille (x,y)(0..dim-1)
       IEtat : Integer; // Etat cellule, vaut ecVierge, ec.... OU, numro de la cellule (1..8)

       LAdja : TList; // liste de toutes les cellules adjacentes [ Coord ]
       LNum : TList; // liste des cellules adjacentes numrotes [ TCellule ]

       IRisque: Integer; // Taux risque aprs Maj, 0%=aucun risque de tomber sur bombe, 100%=bombe certaine
       IIlot: Integer; // Numro d'ilot a laquelle appartient la cellule
       IDrapeauxAutour: Integer; // Nombre de drapeaux adjacents dj poss

       IEtatV : Integer; // Double emploi:
                         // cellule ilot: drapeaux virtuel (-2) ou vierge (0) pendant recherche de solutions
                         // cellule cotire: nbre de drapeaux virtuels poss autour pendant recherche de solutions
       BTestee: Boolean; // pendant la rsolution ilot, marqueur de cellule teste ou non

       procedure MajEtat; // Maj des paramtres, lecture depuis le dmineur
       function GetAdja( num: Integer ): TCellule;  // rcupration d'une cellule adjacente n sur LAdja
       function GetNum( num: Integer ): TCellule; // retourne la cellule numrote adjacente n sur LNum

       procedure CliquerGauche; // clique gauche sur cellule
       procedure CliquerDroit( IEtatVoulu: Integer = 99 ); // clique droit sur cellule

       procedure DebugCocher( IType : Integer = 0 ); // croix, carr sur canvas dmineur
       procedure DebugInfo; // showmessage des infos de la cellule

     end;

// La fentre ...
type
  TFMain = class(TForm)
    PanelDebug: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Labelx: TLabel;
    EditX: TEdit;
    EditY: TEdit;
    ButtonDebugMajGrille: TButton;
    ButtonDebugGo1Tour: TButton;
    ListBoxLATraiter: TListBox;
    ButtonDebugEtatCel: TButton;
    ButtonDebugCouleurCel: TButton;
    ButtonDebugCreerIlots: TButton;
    ButtonDebugResoudreIlots: TButton;
    PanelGeneral: TPanel;
    PanelMain: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    LabelAvancement: TLabel;
    Label5: TLabel;
    RadioGroupNiveau: TRadioGroup;
    ButtonStart: TButton;
    Memo: TMemo;
    ButtonStop: TButton;
    RadioGroupMode: TRadioGroup;
    PanelOptions: TPanel;
    ButtonOptions: TButton;
    ButtonLancer: TButton;
    ButtonFermer: TButton;
    LabelRef: TLabel;
    ComboBoxEditNbParties: TComboBox;
    ImageLogo: TImage;
    LabelNbListesDrapeaux: TLabel;
    ListBoxLSolutions: TListBox;
    RadioGroupIA: TRadioGroup;
    CheckBoxBoost: TCheckBox;
    EditMaxTours: TEdit;
    ButtonInitJournal: TButton;
    ButtonCopierJournal: TButton;
    ButtonLancer2: TButton;
    CheckBoxPremCel: TCheckBox;
    RadioGroupMethode: TRadioGroup;
    CheckBoxRisqueBordure: TCheckBox;
    ComboBoxNom: TComboBox;
    LabelNom: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    GroupBoxLibre: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    EditHauteur: TEdit;
    EditLargeur: TEdit;
    EditMines: TEdit;
    // FORM
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    // INTERFACE
    procedure ButtonStartClick(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);
    procedure ButtonLancerClick(Sender: TObject);
    procedure ButtonFermerClick(Sender: TObject);
    procedure RadioGroupIAClick(Sender: TObject);
    procedure RadioGroupNiveauClick(Sender: TObject);
    procedure EditDimsExit(Sender: TObject);
    procedure ImageLogoClick(Sender: TObject);
    procedure ButtonOptionsClick(Sender: TObject);
    // DEBUG
    procedure ComboBoxEditNbPartiesKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ButtonDebugEtatCelClick(Sender: TObject);
    procedure ButtonDebugCouleurCelClick(Sender: TObject);
    procedure ButtonDebugMajGrilleClick(Sender: TObject);
    procedure ButtonDebugGo1TourClick(Sender: TObject);
    procedure ButtonDebugCreerIlotsClick(Sender: TObject);
    procedure ButtonDebugResoudreIlotsClick(Sender: TObject);
    procedure ListBoxLATraiterDblClick(Sender: TObject);
    procedure ListBoxLSolutionsClick(Sender: TObject);
    procedure ListBoxLSolutionsExit(Sender: TObject);
    procedure ButtonInitJournalClick(Sender: TObject);
    procedure ButtonCopierJournalClick(Sender: TObject);
  public
    SDemineur : string; // Chemin d'accs au dmineur
    HDemineur, HDCDemineur : Cardinal; // Handle Dminineur + son Handle Canevas
    PixOrigine, CelDim, GrilleDim: TPoint; // Paramtres graphiques de la grille
    INbMines : Integer; // Nombre de mines  trouver

    LGrille : TList; // Liste des cellules de la grille [NLigne, LLigne ] avec  LLigne[NCol., TCellule]
    LAtraiter: TStringList; // Liste courante des cases  traiter, Items= [ Risque, coord ], trie par risque

    LIlots: TStringList; // Liste des ilots [ nant, LCelIlot ] avec LCelIlot[ nant, Coord]
    LCotes : TStringList; // Liste des cellules cotiere pour chaque ilot [ nant, LCelCote] avec LCelCote[ nant, Coord]
    LIlotSolutions : TList; // Liste parallles de la rsolution de LIlots [ NIlot, Liste des solution] avec ListeSolutions [ liste de drapeaux ]
    LIdSolution : TStringList; // Liste des ID solution, ne pas stocker 2 fois la meme solution dans LIlotSolutions [IDSolution]
                               // en var. gnral pour Une seule allocation

    ITotalVierges, ITotalDrapeaux : Integer; // Cumuls courants des cases vierges et des drapeaux poss
    BFini: Integer; // Indicateur tat du jeu, 0=en jeu, -1=perdu, 1=gagn
    LJournal: TStringList; // Pour debug, comptages des solutions par stratgie, click sur INIT , jouer, puis sur COPIER

    // OUTILS GENERAUX
    function Lancer( B2emeTentative: Boolean = False ): Boolean; // Lancement du dmineur
    procedure Fermer; // fermeture du dmineur
    function GetCel( x, y: Integer ): TCellule; overload; // Obtention d'une cellule par coord logique grille
    function GetCel( xy: TObject ):TCellule; overload; // Obtention d'une cellule par coord stocke objet ( y shl 16 + x )
    function GetCel( LCelIlot: TStringList; LDrapeaux: TList; IIndice: Integer ): TCellule; overload; // juste pratique pour debug
    procedure SetNiveau; // Dfinition du niveau
    procedure ModePasAPas; // pause, mais possibilit d'y mettre + d'infos pour le user

    // OUTILS GRILLES
    procedure InitGrille( B1erLancement: Boolean ); // Inits des variables, allocation des variables gnrales
    procedure MajGrille( BTout: Boolean = False ); // Mise  jour de toutes les cellules + LATraiter  jour (avec taux)
    procedure DoneGrille; // librations gnrales
    procedure Go1Tour; // 1 tour de jeu, X Actions certaines effectues ou 1 action alatoire
    procedure Done1Tour; // librations les alloc. d'un tour
    procedure DoneSolutions; // librations des solutions d'un tour
    procedure Go( B1erLancement: Boolean ); // Action globale, lance, joue, perd/gagne.
    
    // OUTILS ILOTS
    procedure CreerIlot( IIndexATraiter: Integer; LCelIlot,LCelCote: TStringList; IIlotSet: Integer ); // cration d'un ilot
    procedure CreerIlots; // Cration de tous les ilots
    procedure ResoudreIlot( IIlot: Integer ); // Recherche des solutions d'un ilot - True = Au moins 1 solution
    procedure ResoudreIlots; // Rsolution de tous les ilots, ILotSolutions  jour en sortie
    function TraiterIlots: Boolean; // rsolution et traitement de tous les ilots
    procedure DebugMontrerIlots( BMontrer: Boolean; IIlot: Integer ); // pour debug
    procedure DebugMontrerDrapeaux( IIlot: Integer ); // pour debug

    // OUTILS SOLUTIONS D'ILOTS
    function GetSolutions( IIlot: Integer ): TList; // renvoie la liste des solutions d'un ilot
    function GetSolution( IIlot, ISolution: Integer): TList; // renvoie la liste des drapeaux d'une solution
    function GetDrapeauSolution( IIlot, ISolution, IRang: Integer ): Integer; // renvoie 1 drapeau d'une solution, indice sur Les cellules d'un Ilot LCelIlot
    procedure FusionnerIlots( LFusion: TList ); // Fusion de x ilots dans le 1er; LFusion [ Nilot ] pour recalcul de solution
  end;

var
  FMain: TFMain;

implementation

uses Types;

{$R *.dfm}

//===============================================================================================
// OUTILS LOCAUX BAS NIVEAUX
//===============================================================================================

// Variables pour la fonction de CallBack TestFenetre
var
   Interne_STitreCherche : String; // Titre recherch
   Interne_BTitrePartiel : Boolean; // TRUE pour recherche partielle
   Interne_GFenetre : HWND; // handle de la fentre trouve


// Fonction CallBack de test de fenetre Windows, pour la fonction EnumWindows
function TestFenetre( Fenetre : HWND; Info : Pointer ) : BOOL; export; stdcall;
var
   CTitre : array[ 0..255 ] of Char;
   STitre : String;
begin
     Result := True;
     if ( ( Interne_GFenetre = 0 ) or ( Fenetre <> Interne_GFenetre ) )
        and IsWindowVisible( Fenetre ) then
        begin // Recherche du titre de la fentre en cours
        GetWindowText( Fenetre, CTitre, 255 );
        if StrLen( CTitre ) > 0 then
           begin // Analyse du titre de la fentre en cours
           STitre := UpperCase( StrPas( CTitre ) );
           Result := not ( ( Interne_BTitrePartiel and ( Pos( Interne_STitreCherche, STitre ) <> 0 ) )
                           or ( Interne_STitreCherche = STitre ) );
           if not Result then // Fentre trouve
           if Interne_GFenetre <> 0  then
              begin // Recherche et analyse du module en cours
              CTitre := '';
              GetModuleFileName( GetWindowLong( Fenetre, GWL_HINSTANCE ), CTitre, 255 );
              STitre := ExtractFileName( UpperCase( StrPas( CTitre ) ) );
              Result := STitre <> UpperCase( ExtractFileName( Application.ExeName ) );
              if not Result
                 then Interne_GFenetre := Fenetre; // Fentre trouve OK
              end
           else Interne_GFenetre := Fenetre; // Fentre trouve OK
           end;
        end;
end;

// tester si l'appli est active, l'active ou non en option
function ApplicationActive( const STitre : String;
                            BTitrePartiel : Boolean = False;
                            BApplicationCourante : Boolean = False;
                            BActiver : Boolean = True ) : HWND;

begin
     if BApplicationCourante
       then Interne_GFenetre := Application.Handle
       else Interne_GFenetre := 0;
     Interne_STitreCherche := UpperCase( STitre );
     Interne_BTitrePartiel := BTitrePartiel;
     if Windows.EnumWindows( @TestFenetre, 0 )
       then Result := 0 // Fentre non trouve
     else
       begin // Fentre trouve
       Result := Interne_GFenetre;
       if BActiver then
         begin // Activation de la fentre trouve
         Windows.SetForegroundWindow( Application.Handle );
         Windows.BringWindowToTop( Result );
         Windows.SetActiveWindow( Result );
         Windows.ShowWindow( Result, SW_SHOWNORMAL );
         end;
       end;
end;

// Validation et Init des Handles Dmineur
procedure BN_Valide( BSilent: Boolean = False );
var
   i : Integer;
   HTemp: Cardinal;
begin
     if ( FMain.CheckBoxBoost.Checked ) and ( FMain.HDemineur <> 0 ) then Exit;
     HTemp := ApplicationActive( FMain.ComboBoxNom.Text, False, False, False );
     // 2eme Tentative - on attend un peu
     if HTemp = 0 then
       for i := 0 to 5 do // tentatives d'activation 
         begin
         HTemp := ApplicationActive( FMain.ComboBoxNom.Text, False, False, True );
         if HTemp <> 0 then break;
         Sleep( 150 );
         end;
     // Vrifications
     if HTemp = 0 then // NON TROUVE -> ERREUR
       begin
       if not BSilent
         then ShowMessage( 'ERREUR DEMINEUR!!' );
       FMain.HDCDemineur := 0;
       Abort;
       end
     else  // DEMINEUR TROUVE -> INIT DU DC Canvas
       if FMain.HDemineur <> HTemp then
         begin
         FMain.HDemineur := HTemp;
         HTemp := GetDC( FMain.HDemineur );
         if HTemp = 0 then
           begin
           if not BSilent
             then ShowMessage( 'ERREUR INTERNE DEMINEUR!' );
           Abort;
           end
         else
           if HTemp <> FMain.HDCDemineur then
             begin
             if FMain.HDCDemineur <> 0 // libration de l'ancien DC si existant
               then try ReleaseDC( FMain.HDemineur, FMain.HDCDemineur ); except end;
             FMain.HDCDemineur := HTemp;
             end;
         end;
end;

// rcupration pixel dmineur
function BN_Couleur( HCanvas: Cardinal; x, y: Integer ): LongWord;
begin
     BN_Valide;
     Result := GetPixel( HCanvas, x, y ) and $ffffff;
end;

// simulation clik gauche dmineur
procedure BN_CliquerGauche( HAppli: Cardinal; x, y : Integer );
begin
     BN_Valide;
     Sendmessage(HAppli, WM_LBUTTONDOWN, MK_LBUTTON, y shl 16 + x);
     SendMessage(HAppli, WM_LBUTTONUP, 0, 0);
end;

// simulation click droit dmineur
procedure BN_CliquerDroit( HAppli: Cardinal; x, y : Integer );
begin
     BN_Valide;
     Sendmessage(HAppli, WM_RBUTTONDOWN, MK_RBUTTON, y shl 16 + x);
     SendMessage(HAppli, WM_RBUTTONUP, 0, 0);
end;

// simulation choix niveau via menu - je sais j'aurais pu gnraliser les keybd_event ...
procedure BN_MenuNiveau( HAppli: Cardinal; INiveau: Integer;
                         SHauteur: string = ''; SLargeur: string = ''; SNbMines:string = '' );
var
   i : Integer;
begin
     BN_Valide;
     SetForegroundWindow(HAppli);
     sleep( 50 ); 
     keybd_event(VK_LMENU, 0, 0, 0);
     keybd_event($50, 0, 0, 0);
     keybd_event($50, 0, KEYEVENTF_KEYUP, 0);
     keybd_event(VK_LMENU, 0, KEYEVENTF_KEYUP, 0);
     for i := 0 to INiveau do
       begin
       keybd_event(VK_DOWN, 0, 0, 0);
       keybd_event(VK_DOWN, 0, KEYEVENTF_KEYUP, 0);
       end;
     keybd_event(VK_RETURN, 0, 0, 0);
     keybd_event(VK_RETURN, 0, KEYEVENTF_KEYUP, 0);
     // Niveau Libre - Choix par simulation touche
     if INiveau = 3 then // temps d'attentes, les keybd_event n'attendents pas de retour... 
       begin
       // TAB x 2
       Sleep( 100 );
       keybd_event(VK_TAB, 0, 0, 0);
       keybd_event(VK_TAB, 0, KEYEVENTF_KEYUP, 0);
       Sleep( 100 );
       keybd_event(VK_TAB, 0, 0, 0);
       keybd_event(VK_TAB, 0, KEYEVENTF_KEYUP, 0);
       Sleep( 100 );
       // HAUTEUR
       for i := 1 to Length( SHauteur ) do
         begin
         keybd_event( Ord( SHauteur[ i ] ) + $30, 0, 0, 0);
         keybd_event( Ord( SHauteur[ i ] ) + $30, 0, KEYEVENTF_KEYUP, 0);
         end;
       Sleep( 100 );
       keybd_event(VK_TAB, 0, 0, 0);
       keybd_event(VK_TAB, 0, KEYEVENTF_KEYUP, 0);
       Sleep( 100 );
       // LARGEUR
       for i := 1 to Length( SLargeur ) do
         begin
         keybd_event( Ord( SLargeur[ i ] ) + $30, 0, 0, 0);
         keybd_event( Ord( SLargeur[ i ] ) + $30, 0, KEYEVENTF_KEYUP, 0);
         end;
       Sleep( 100 );
       keybd_event(VK_TAB, 0, 0, 0);
       keybd_event(VK_TAB, 0, KEYEVENTF_KEYUP, 0);
       Sleep( 100 );
       // MINES
       for i := 1 to Length( SNbMines ) do
         begin
         keybd_event( Ord( SNbMines[ i ] ) + $30, 0, 0, 0);
         keybd_event( Ord( SNbMines[ i ] ) + $30, 0, KEYEVENTF_KEYUP, 0);
         end;
       Sleep( 100 );
       keybd_event(VK_RETURN, 0, 0, 0);
       keybd_event(VK_RETURN, 0, KEYEVENTF_KEYUP, 0);
       Sleep( 200 );
       // il faut le temps de souffler, pas d'attente de retour...
       SetForegroundWindow(HAppli);
       end;
     Sleep( 150 );
end;

// simulation nouvelle partie via F2
procedure BN_MenuNouveau( HAppli: Cardinal );
begin
     BN_Valide;
     SetForegroundWindow(HAppli);
     sleep(50);
     // via F2 direct pour viter clignotement du droulement menu
     keybd_event(VK_F2, 0, 0, 0);
     keybd_event(VK_F2, 0, KEYEVENTF_KEYUP, 0);
     Sleep( 50 );
     (*
     // via menu
     keybd_event(VK_LMENU, 0, 0, 0);
     keybd_event($50, 0, 0, 0);
     keybd_event($50, 0, KEYEVENTF_KEYUP, 0);
     keybd_event(VK_LMENU, 0, KEYEVENTF_KEYUP, 0);
     keybd_event(VK_RETURN, 0, 0, 0);
     keybd_event(VK_RETURN, 0, KEYEVENTF_KEYUP, 0);
     *)
end;

//===============================================================================================
// OUTILS LOCAUX
//===============================================================================================
// formatage d'une chaine plaque  droite (pour le tri des taux numriques dans une TStringList)
function SFormatDroite( const SChaine : String; ILongueur : Longint; CRemplissage : Char = ' ' ) : String;
var
   ILongueurInitiale : Longint;
begin
     Result := SChaine;
     ILongueurInitiale := Length( SChaine );
     if ILongueurInitiale < ILongueur
       then Result := StringOfChar( CRemplissage, ILongueur - ILongueurInitiale ) + Result
     else
       if ILongueurInitiale > ILongueur
         then SetLength( Result, ILongueur );
end;

// formatge pour visu dure
function HeureToChaine( DTime : TDateTime; const SMasque : String = ':nn' ) : String;
var
   WHour, WMin, WSec, WMSec : Word;
   WYear, WMonth, WDay: word;
   WYearRef, WMonthRef, WDayRef : Word;
begin
     Result := '';
     if DTime <> 0.00 then
       begin
       if DTime < 0 then
         begin // Ngatif
         Result := '-';
         DTime := Abs( DTime );
         end;
       DecodeTime( DTime, WHour, WMin, WSec, WMSec );
       DecodeDate( DTime, WYear, WMonth, WDay );
       DecodeDate( 0, WYearRef, WMonthRef, WDayRef );
       WYear := WYear - WYearRef;
       WMonth := WMonth - WMonthRef;
       WDay := WDay-WDayRef;
       if WYear <> 0  then Result := Result + ' ' + IntToStr( WYear ) + ' an.';
       if WMonth <> 0 then Result := Result + ' ' + IntToStr( WMonth ) + ' mois';
       if WDay <> 0   then Result := Result + ' ' + IntToStr( WDay ) + ' ans';
       if WHour <> 0  then Result := Result + ' ' + IntToStr( WHour ) + ' h.';
       if WMin <> 0   then Result := Result + ' ' + IntToStr( WMin ) + ' min.';
       if ( WSec <> 0 ) or ( WMSec <> 0 )
         then Result := Result + ' ' + FormatDateTime( 's.zzz', EncodeTime( 0, 0, WSec, WMSec ) ) + ' sec.';
       end;
end;

//===============================================================================================
// CLASSE CELLULE
//===============================================================================================

// Obtention de la n-ieme cellule adjacente autour de la cellule
function TCellule.GetAdja( num: Integer ): TCellule;
var
   ITemp : Integer;
begin
     ITemp := Integer( LAdja.Items[ num ] );
     result := FMain.GetCel( ITemp shr 16, ITemp and $ff );
end;

// Obtention de la n-ieme cellule numrot autour de la cellule
function TCellule.GetNum( num: Integer ): TCellule;
begin
     Result := TCellule( LNum[ num ] );
end;

// Mise  jour de l'tat de la cellule par lecture physique sur dmineur
procedure TCellule.MajEtat;
var
   x, y: Integer;
   xc, yc: Integer;
   Couleur: LongWord;
begin
     // Lecture dmineur
     with FMain do
       begin
       x := PPos.X  * CelDim.X + PixOrigine.X;
       y := PPos.Y  * CelDim.Y + PixOrigine.Y;
       xc := x + CelDim.X div 2;
       yc := y + CelDim.Y div 2;
       Couleur := BN_Couleur( HDCDemineur, xc, yc );
       end;

     // Mise  jour de l'tat / couleur - coord hard
     case Couleur of
     
       // Cases numrotes

       $ff0000 :                IEtat := 1;
       $008000, $008200 :       IEtat := 2;
       $0000ff :                if ( GetPixel( FMain.HDCDemineur, x+8, y+10 ) <> $000000 )
                                  then IEtat := 3
                                  else IEtat := ecBombeM; // bombe manque
       $800000, $840000 :       IEtat := 4;
       $000080, $000084 :       IEtat := 5;
       $808000, $848200 :       IEtat := 6;
       $808080, $848284 :       IEtat := 8;
       // le 7 est dfini plus bas

       // cases d'tat

       $C0C0C0, $C6C3C6 :       begin
                                Couleur := GetPixel( FMain.HDCDemineur, x+1, y+1);
                                if Couleur = $ffffff
                                  then IEtat := 0 // vierge
                                else
                                  if GetPixel( FMain.HDCDemineur, xc+1, yc+1 ) = $000000
                                    then IEtat := 7
                                    else IEtat := ecDeminee;
                                end;
       $000000 :                begin
                                Couleur := GetPixel( FMain.HDCDemineur, x + 6, y + 4 );
                                if Couleur = $0000ff
                                  then IEtat := ecDrapeau
                                  else
                                if ( Couleur = $000000 ) and ( GetPixel( FMain.HDCDemineur, x+7, y+7 ) <> $ffffff )
                                  then IEtat := ecPtInt 
                                  else IEtat := ecBombe;
                                end;
       else                     IEtat := ecDeminee; // ne devrait jamais arriver
     end;
end;

// Clique Gauche cellule
procedure TCellule.CliquerGauche;
var
   x, y : Integer;
begin
     with FMain do
       begin
       x := PPos.X * CelDim.X + PixOrigine.X + CelDim.X div 2;
       y := PPos.Y * CelDim.Y + PixOrigine.Y + CelDim.Y div 2;
       BN_CliquerGauche( HDemineur, x, y );
       MajEtat;
       if Ietat = ecBombe then BFini := -1; // l, on sait tout de suite, c'est perdu !
       end;
end;

// Clic droit Cellule, forcage ventuel sur un tat souhait (3 tats=vierge, ?, drapeau)
procedure TCellule.CliquerDroit( IEtatVoulu: Integer = 99 );
var
   i : Integer;
   x, y : Integer;
begin
     for i := 0 to 2 do // boucle clic droit jusqu'a trouver rsultat, 3 maxi pour garde-fou, sinon simple clic(99)
     with FMain do
       begin
       x := PPos.X * CelDim.X + PixOrigine.X + CelDim.X div 2;
       y := PPos.Y * CelDim.Y + PixOrigine.Y + CelDim.Y div 2;
       BN_CliquerDroit( HDemineur, x, y );
       MajEtat;
       if ( IEtat = IEtatVoulu ) or ( IEtatVoulu = 99 )
         then Break;
       end;
end;

// tracage sur canvas dmineur d'une croix
procedure TCellule.DebugCocher( IType : Integer = 0 );
var
   x, y : Integer;
   IBord: Integer;
begin
     BN_Valide;
     with FMain do
       begin
       x := PPos.X * CelDim.X + PixOrigine.X;
       y := PPos.Y * CelDim.Y + PixOrigine.Y;
       if IType = 0 then
         begin // croix dcale, pour eviter erreur sur relecture cellule
         MoveToEx( HDCDemineur, x+5,y, nil );
         LineTo( HDCDemineur, x+CelDim.X-1, y+CelDim.Y );
         MoveToEx( HDCDemineur, x+CelDim.Y-1, y, nil );
         LineTo( HDCDemineur, x+5, y+CelDim.Y );
         end
       else
       if IType = 1 then
         begin // carr
         IBord := 4;
         MoveToEx( HDCDemineur, x+IBord,y+IBord, nil );
         LineTo( HDCDemineur, x + CelDim.X -IBord, y+IBord );
         LineTo( HDCDemineur, x + CelDim.X -IBord, y+CelDim.Y - IBord );
         LineTo( HDCDemineur, x + IBord, y+CelDim.Y - IBord );
         LineTo( HDCDemineur, x+IBord,y+IBord  );
         end;
       end;
end;

// affichage infos cellule
procedure TCellule.DebugInfo;
begin
     ShowMessage( 'IEtat = ' + IntToStr( IEtat ) + #13 +
                  'LAdja.Count = ' + IntToStr( LAdja.Count ) + #13 +
                  'LNum.Count = ' + IntToStr( LNum.Count ) + #13 +
                  //'LVierges.Count = ' + IntToStr( LVierges.Count ) + #13 +
                  'IDrapeauxAutour = ' + IntToStr( IDrapeauxAutour ) + #13 +
                  'N Ilot = ' + IntToStr( IIlot ) + #13 +
                  'IRisque = ' + IntToStr( IRisque ) + #13 +
                  'IEtatV = ' + IntToStr( IEtatV ) );
end;

//===============================================================================================
// OUTILS FORM
//===============================================================================================

// Lancement du dmineur
function TFMain.Lancer( B2emeTentative: Boolean = False ): Boolean;
var
   i : Integer;
   HTemp: Cardinal;
begin
     Result := False;
     if not B2emeTentative then Fermer;
     // LAncement du dmineur - et rcupration Handle dans un dlai de 2sec max.
     if ShellExecute(application.Handle,'open', PChar( SDemineur ), nil, nil, SW_NORMAL) < 32
       then Exit;
     for i := 0 to 10 do
       begin
       HTemp := ApplicationActive( ComboBoxNom.Text, False, False, True );
       if HTemp <> 0 then Break;
       Sleep( 200 );
       end;
     // 2eme tentative de dmarrage
     if ( HTemp = 0 ) and ( not B2emeTentative ) then Lancer( True );
     // Maj des var systme
     BN_Valide;
     Result := true;
end;

procedure TFMain.Fermer;
begin
     try
     Application.ProcessMessages;
     if HDemineur <> 0
       then SendMessage( HDemineur, WM_CLOSE, 0, 0 );
     Sleep( 50 );
     HDemineur := 0;
     HDCDemineur := 0;
     except
     HDemineur := 0;
     HDCDemineur := 0;
     end;
end;

procedure TFMain.SetNiveau;
begin
     // PARAMETRES
    GrilleDim.X := StrToInt( EditLargeur.Text );
    GrilleDim.Y := StrToInt( EditHauteur.Text );
    INbMines := StrToInt( EditMines.Text );
    BN_MenuNiveau( HDemineur, RadioGroupNiveau.ItemIndex, EditHauteur.Text, EditLargeur.Text, EditMines.Text );
end;

function TFMain.GetCel( x, y: Integer ):TCellule;
begin
     result := TCellule( TList( LGrille.Items[ y ] ).Items[ x ] );
end;

function TFMain.GetCel( xy: TObject ):TCellule;
var
   x, y : Integer;
begin
     x := Integer( xy ) and $ff;
     y := Integer( xy ) shr 16;
     Result := GetCel( x, y );
end;

function TFMain.GetCel( LCelIlot: TStringList; LDrapeaux: TList; IIndice: Integer ): TCellule;
begin
     Result := GetCel( LCelIlot.Objects[ Integer( LDrapeaux[ IIndice ] ) ] );
end;

// A upgrader pour User
procedure TFMain.ModePasAPas;
begin
     if (MessageDlg('Continuer mode pas  pas ?', mtWarning, [mbYes, mbNo], 0) = mrNo)
       then RadioGroupMode.ItemIndex := 0;
end;

//===============================================================================================
// OUTILS GRILLE
//===============================================================================================

// Prparation et allocations de LGrille et ses TCellule, lancement du jeu, niveau
procedure TFMain.InitGrille( B1erLancement: Boolean );
var
   i, j: Integer;
   x, y: Integer;
   LLigne : TList;
   MaCellule : TCellule;
begin
     if B1erLancement then
       begin // LANCEMENT DU JEU, ALLOC DE LA GRILLE
       // Lancement ventuel dmineur
       DoneGrille;
       if not Lancer then
         begin
         BFini := -1;
         Exit;
         end;
       SetNiveau;
       // Init de la grille LGRille, reflet de la grille du dmineur
       LGrille := TList.Create;
       for y := 0 to GrilleDim.Y - 1 do
         begin
         LLigne := TList.Create;
         LGrille.Add( LLigne );
         for x := 0 to GrilleDim.X - 1 do
           begin
           MaCellule := TCellule.Create;
           LLigne.Add( MaCellule );
           with MaCellule do
             begin
             PPos := Point( x, y );
             IEtat := ecVierge;
             IIlot := -1;
             LAdja := TList.Create;
             LNum := TList.Create;
             for i := -1 to 1 do
               for j := -1 to 1 do
                 if ( i <> 0 ) or ( j <> 0 ) then
                   if ( ( x + i ) >= 0 ) and ( ( y + j ) >= 0 ) and
                      ( ( x + i ) < GrilleDim.X ) and ( ( y + j ) < GrilleDim.Y )
                     then LAdja.Add( Pointer( ( x + i ) shl 16 + y + j ) );
             end;
           end;
         end;
       end
     else
       begin // JEU DEJA OUVERT - Inits simples
       BN_MenuNouveau( HDemineur );
       BN_Valide;
       // RAZ etat cellules
       for y := 0 to GrilleDim.Y - 1 do
         for x := 0 to GrilleDim.X - 1 do
           with GetCel( x, y ) do
             begin
             IEtat := ecVierge;
             IIlot := -1;
             end;
       end;
    // 1ere Mise  jour de la grille, vrification que la partie est bien vierge
   BFini := 0;
   MajGrille( True );
   // Retentative d'activation du dmineur 
   if BFini <> 0 then 
     for i := 0 to 10 do
       begin
       BN_Valide;
       BN_MenuNouveau( HDemineur );
       Sleep( 150 );
       BFini := 0;
       MajGrille( True );
       if BFini = 0 then Break; 
       end;
   // Impossible de rcuprer un tat cohrent, par dfaut partie perdue!
   if BFini <> 0 then
     begin
     BFini := -1; // partie perdue par dfaut
     try Fermer; except end;
     Memo.Lines.Add( 'Une erreur est survenu sur le dmarrage d''une partie' );
     Abort;
     end;
end;

// Objectif:
// -> Mise  jour des var. de toutes les TCellules de la grille LGRille
// -> prparer LATraiter avec taux risque simple
procedure TFMain.MajGrille( BTout: Boolean = False );
var
   i : Integer;
   x, y: Integer;
   IRisqueAdja : Integer;
   SLigne : string;
   IBombes, IVierges: Integer;
   IRisqueIsole : Integer; // Taux du risque des cellules isoles
begin
     if BFini <> 0 then Exit; // Partie termine, pas la peine de mettre  jour la grille

     // Mise  jour de l'tat de chaque cellule et des var d'tat
     ITotalVierges := 0;
     ITotalDrapeaux := 0;
     for y := 0 to GrilleDim.Y - 1 do
       for x := 0 to GrilleDim.X - 1 do
         with GetCel( x, y ) do
           begin
           if ( IEtat = ecVierge ) or BTout then MajEtat; // maj des cellules non cliques uniquement
           IRisque := -1; // reset risque
           IIlot := -1; // reset appartenance ilot
           IDrapeauxAutour := 0;
           if IEtat = ecVierge then Inc( ItotalVierges );
           if IEtat = ecDrapeau then Inc( ITotalDrapeaux );
           LNum.Clear;
           end;
     if ( ITotalVierges = 0 ) then
       begin
       BFini := 1;
       Exit;
       end;

     // Mj Cellules, des drapeaux adjacents, doit se faire ncessairement une fois la grille complte Mj.
     for y := 0 to GrilleDim.Y - 1 do
       for x := 0 to GrilleDim.X - 1 do
         with GetCel( x, y ) do
           for i := 0 to LAdja.Count - 1 do
             if GetAdja( i ).IEtat > 0 then LNum.Add( GetAdja( i ) ) else
             if GetAdja( i ).IEtat = ecDrapeau then Inc( IDrapeauxAutour );

     // Taux simple du risque des cellules adjacentes  des cellules numrotes, 0% = aucune bombe
     for y := 0 to GrilleDim.Y - 1 do
         for x := 0 to GrilleDim.X - 1 do
         with GetCel( x, y ) do
           if IEtat > 0 then // CELLULES NUMEROTEES
             begin
             // Calcul du risque des cellules adjacentes
             IBombes := 0;
             IVierges := 0;
             for i := 0 to LAdja.Count - 1 do
               with GetAdja( i ) do
                 if IEtat = ecDrapeau then Inc( IBombes ) else
                 if IEtat = ecVierge then Inc( IVierges );
             if IVierges = 0 then Continue; // pas de cellule vierge autour du numros -> rien  mj
             IRisqueAdja := Round( ( IEtat - IBombes ) / IVierges * 100 );
             // Mise  jour du risque des cellules adjacentes vierges
             for i := 0 to LAdja.Count - 1 do
               with GetAdja( i ) do
                 if IEtat = ecVierge then
                   begin
                   if ( IRisqueAdja in [ 0, 100 ] ) // 0 et 100 prioritaires
                     then IRisque := IRisqueAdja
                     else
                   if not ( IRisque in [ 0, 100 ] ) then // 0 et 100 prioritaires
                     case RadioGroupMethode.ItemIndex of
                       // risque simple, le risque max. est prioritaire
                       0 : IRisque := Max( IRisqueAdja, IRisque );
                       // Moyenne du risque avec mauvaise pondration (!) -> donc moins fiable  mon avis
                       1 : IRisque := Round(  ( 1 - ( 1 - IRisqueAdja/100 ) * ( 1 - IRisque/100 ) ) * 100  );
                     end;
                   end;
             end;

     // risque des cellules isoles, cellules vierges dont le risque est encore non dfini
     IRisqueIsole := Round( ( INbMines - ITotalDrapeaux ) / ITotalVierges * 100 );
     for y := 0 to GrilleDim.Y - 1 do
         for x := 0 to GrilleDim.X - 1 do
         with Getcel( x, y ) do
           if ( IEtat = ecVierge ) and ( IRisque = -1 )
             then IRisque := IRisqueIsole;

     // Liste des cellules A traiter
     LAtraiter.Clear;
     for y := 0 to GrilleDim.Y - 1 do
         for x := 0 to GrilleDim.X - 1 do
           with GetCel( x, y ) do
             if IRisque >= 0 then // risque mis  jour, on alimente LATraiter
               begin
               LAtraiter.AddObject( SFormatDroite( IntToStr( IRisque), 3, '0' ),
                                    TObject( PPos.Y shl 16 + PPos.X ) );
               end;
     LAtraiter.Sort;


     //*** DEBUG
     if Paneldebug.Visible then
       begin
       ListBoxLAtraiter.Clear;
       for i := 0 to LAtraiter.Count - 1 do
         begin
         x :=  Integer( LAtraiter.Objects[ i ] ) and $ff;
         y := Integer( LAtraiter.Objects[ i ] ) shr 16;
         SLigne := LAtraiter[ i ] + '% - (' + IntToStr( x ) + ',' + IntToStr(  y ) + ')';
         ListBoxLAtraiter.AddItem( SLigne, nil );
         end;
       Labelx.Caption := IntToStr( ListBoxLAtraiter.count ) + ' cellules vierges';
       ListBoxLAtraiter.Refresh;
       Application.ProcessMessages;
       end;
end;

// D-allocation globalle de la grille et de son contenu
procedure TFMain.DoneGrille;
var
   x, y:Integer;
   MaCellule : TCellule;
begin
     if Assigned( LGrille ) then
       begin
       for y := 0 to GrilleDim.Y - 1 do
         begin
         for x := 0 to GrilleDim.X - 1 do
           begin
           MaCellule := GetCel( x, y );
           MaCellule.LAdja.Free;
           MaCellule.LNum.Free;
           MaCellule.Free;
           end;
         TList( LGrille[ y ] ).Free;
         end;
       FreeAndNil( LGrille );
       end;
end;

// 1 passe de jeux
// LAtraiter possede des cellules sures -> on traite et c'est fini
// sinon, gestion des ilots
procedure TFMain.Go1Tour;
var
   IIndex: Integer;
   BSafe: Boolean;
   BHasard: Boolean;
begin
     BSafe := False;
     try
     // Lecture de la grille dmineur, mj des var., LATraiter  jour
     MajGrille;
     if BFini <> 0 then Exit; // partie termine gagne/perdue

     // Dminage safe (taux = 0%)
     IIndex := LAtraiter.IndexOf( '000' );
     if IIndex <> -1 then
     while ( IIndex < LAtraiter.Count ) and ( LAtraiter[ IIndex ] = '000' ) do
       begin
       BSafe := True;
       GetCel( LAtraiter.Objects[ IIndex ] ).CliquerGauche;
       Inc( IIndex );
       end;

     // Drapeaux surs  poser (taux=100% de bombes)
     IIndex := LAtraiter.IndexOf( '100' );
     if IIndex <> -1 then
     while ( IIndex < LAtraiter.Count ) and ( LAtraiter[ IIndex ] = '100' ) do
       begin
       BSafe := True;
       GetCel( LAtraiter.Objects[ IIndex ] ).CliquerDroit( ecDrapeau );
       Inc( IIndex );
       end;

     // Mthode bte choue -> gestion des ilots si mode rflexion -
     // sinon dminage de la cellule au taux le plus bas (LAtraiter[0] donc...)
     if not BSafe then
       begin
       // Choix stratgie
       BHasard := True;
       if RadioGroupIA.ItemIndex > 0 then
         begin
         CreerIlots; // crations des ilots
         BHasard := not TraiterIlots; // rsolution des ilots - False si ca donne rien
         end;
       // IA ilots choue ou choix user mode bete - Prise du 1er element au taux le plus bas
       // La toute 1ere cellule au hasard dans le jeu par contre
       if BHasard then
         begin
         if ( LAtraiter.Count < GrilleDim.X * GrilleDim.Y ) or ( not CheckBoxPremCel.Checked )
           then Getcel( LAtraiter.Objects[ 0 ] ).CliquerGauche
           else Getcel( LAtraiter.Objects[ Random( LAtraiter.count ) ] ).CliquerGauche
         end;
       end;

     // Librations
     finally Done1Tour; end;
end;

// D-allocation des allocs faites sur 1 tour
procedure TFMain.Done1Tour;
var
   i : Integer;
   LCelIlot: TStringList;
   LCelCote : TStringList;
begin
     DoneSolutions;
     // Les ilots construits
     for i := 0 to LIlots.Count - 1 do
       begin
       LCelIlot := TStringList( LIlots.Objects[ i ] );
       if Assigned( LCelIlot )
         then FreeAndNil( LCelIlot );
       LCelCote := TStringList( Lcotes.Objects[ i ] );
       if Assigned( LcelCote )
         then FreeAndNil( LCelCote );
       end;
     LIlots.Clear;
     LCotes.Clear;
end;

// Librations des listes de solutions
procedure TFMain.DoneSolutions;
var
   i,j : Integer;
begin
     for i := 0 to LIlotSolutions.Count - 1 do
       if Assigned( GetSolutions( i ) ) then
         begin
         for j := 0 to GetSolutions( i ).Count - 1 do
           if Assigned( GetSolution( i, j ) )
             then GetSolution( i, j ).Free;
         GetSolutions( i ).Free;
         end;
     LIlotSolutions.Clear;
end;

procedure TFMain.Go( B1erLancement: Boolean );
begin
     InitGrille( B1erLancement );
     while ( BFini = 0 ) do
       begin
         try
         
         Go1Tour;

         except BFini := -1; ButtonStop.Tag := 1; end; // erreur imprvue -> partie perdue (ne doit pas arriver)
       // mode pas  pas
       if RadioGroupMode.ItemIndex = 3 then ModePasAPas;
       end;
end;

//===============================================================================================
// OUTILS ILOT
//===============================================================================================

// Cration d'un ilot - sans rcursivit,
// IIndexAtraiter: Cellule de dpart dans la liste LATraiter
// LCelIlot: pour le retour -> Liste des cellules des cotes de l'ilot
// LCelCote : pour le retour -> Cellules numrotes bordant l'ilot
// IIlotSet: N d'ilot d'appartenance, affect  toutes les cellules de l'ilot cr
procedure TFMain.CreerIlot( IIndexATraiter: Integer; LCelIlot, LCelCote: TStringList; IIlotSet: Integer );
var
   i, j: Integer;
   IIndexCote: Integer; // Curseur sur LCelCote
   MaCel0, Macel1, MaCel2 : TCellule; // Cellule en cours, Cellules adjacentes, Cellules adjacentes des cellules adjacentes (!)
begin
     LCelIlot.Clear;
     LCelCote.Clear;
     //1ere cellule, point de dpart
     MaCel0 := GetCel( LATraiter.Objects[ IIndexATraiter ] ).LNum[ 0 ];
     LCelCote.AddObject( '', TObject( MaCel0.PPos.Y shl 16 + MaCel0.PPos.X ) );
     MaCel0.IIlot := IIlotSet;
     IIndexCote := 0;
     while ( IIndexCote < LCelCote.Count ) do
       begin
       MaCel0 := GetCel( LCelCote.Objects[ IIndexCote ] );
       for i := 0 to MaCel0.LAdja.Count - 1 do
         begin
         MaCel1 := MaCel0.GetAdja( i );
         if Macel1.IEtat <> ecVierge then continue; // rejet des cellules non vierges
         if MaCel1.IIlot <> -1 then continue; // rejet des cellules appartenant dj  un ilot
         LCelIlot.AddObject( '', TObject( MaCel1.PPos.Y shl 16 + MaCel1.PPos.X ) ); // AJOUT DANS LCELILOT
         MaCel1.IIlot := IIlotSet;
         for j := 0 to MaCel1.LNum.Count - 1 do
           begin
           MaCel2 := MaCel1.GetNum( j );
           if MaCel2.IEtat <= 0 then Continue; // rejet si cellule non numrote
           if MaCel2.IIlot <> -1 then Continue; // rejet si cellule appartenant dj  un ilot
           LCelCote.AddObject( '', TObject( MaCel2.PPos.Y shl 16 + MaCel2.PPos.X ) ); // AJOUT DANS LCELCOTE
           MaCel2.IIlot := IIlotSet;
           end;
         end;
       Inc( IIndexCote );
       end;
end;

// Cration des ensembles d'ilots constituant la grille
// Balayage de LATraiter, cration d'ilot sur chaque 1ere Cellule numrote non affecte  un ilot
procedure TFMain.CreerIlots;
var
   i : Integer;
   LCelIlot : TStringList;
   LCelCote : TStringList;
begin
     // Cration des ilots
     LIlots.Clear;
     LCotes.Clear;
     for i := 0 to LAtraiter.Count - 1 do
     with GetCel( LATraiter.Objects[ i ] ) do
       begin
       // Prise de la bonne prochaine cellule
       if IIlot <> -1 then Continue;
       if LNum.Count = 0 then Continue;
       // LA cellule a un bord numrot et ne fait pas partie d'un ilot, on en cr un
       LCelIlot := TStringList.Create;
       LCelCote := TStringList.Create;
       CreerIlot( i, LCelIlot, LCelCote, LIlots.Count );
       LIlots.AddObject( '', LCelIlot ); 
       LCotes.AddObject( '', LCelCote );
       end;
end;

// OBJECTIF: pour un ilot donn, alimenter LIlotDrapeaux avec le maximum
// de solutions trouves 
// Alimentation de LIlotDrapeaux avec les X solutions trouves. Une solution trouve = LDrapeaux.
// Stratgie: la recherche des solutions se passe en 2 parties: 
//   - une recherche par parcours sur LCelIlot, par incrments Nombre 1er pour viter les parcours similaires
//   - une recherche par positionnement alatoire sur les cellules
// -> dosage empirique par tude des solutions trouves, du nombre des itrations par cycle.
procedure TFMain.ResoudreIlot( IIlot: Integer );
var
   LCelIlot: TStringList; // liste des cellules de l'ilot courant
   LCelCote: TStringList; // idem pour la cote
   IMaxDrapeaux : Integer; // Nbre max. de drapeau  poser sur l'ilot
   IIdSolution: Integer; // ID de la solution en cours
   IMaxTours: Integer; // Nombre maxi de tour sur les incr. nombres premiers

   // Renvoie true, si l'ensemble des cellules places est cohrent -> c'est une solution
   // Le dpot des drapeaux se fait par TCellule.IEtatV = ecDrapeau
   function UneSolution( IRang, IPasse, ICycle: Integer ): Boolean;
   var
      i, j : Integer;
      MaCel : TCellule; // cellule en cours de test
      BDrapeauOK : Boolean; // la cellule peut recevoir un drapeaux
      INbTours: Integer; // nombre de tours dans la recherche de la solution
      IIndex: Integer; // pour trouver cellule courante
      IDepotV: Integer; // comptage du nombre de drapeaux virtuels pos
      INbTestees: Integer; // Nombre de cellules marques BTestee
      BSortie: Boolean; // condition de sortie de la rsolution
   begin
        Result := False;
        // passe inutile, le positionnement reomberait systmatiquement sur la meme cellule
        if ICycle = 0 then
          if ( NBPREM[ IPasse ] = LCelIlot.Count )
            then Exit;
        // Inits, on efface tous les tats virtuels de l'ilot, et demarquage de tests des cellules
        for i := 0 to LCelIlot.Count - 1 do
        with GetCel( LCelIlot.Objects[ i ] ) do
          begin
          IEtatV := ecVierge;
          BTestee := False;
          end;
        for i := 0 to LCelCote.Count - 1
          do GetCel( LCelCote.Objects[ i ] ).IEtatV := 0; // init compteur pose Drapeuax Virtuel autour
        // Inits compteurs
        INbTours := 0;
        IIdSolution := 0;
        IDepotV := 0;
        INbTestees := 0;
        // Remplissage avec des Drapeaux Virtuels IEtatV=ecDrepaux tant qu'il reste
        // des cellules non ventile de l'ilot, pose on non du drapeaux / cohrence
        BSortie := False;
        while ( not BSortie ) and ( IDepotV < IMaxDrapeaux ) do
          try
          // Stratgie de positionnement / au n du cycle
          if INbTours = 0
            then IIndex := IRang // toujours la 1ere cellule coche au dpart
          else
            case ICycle of
              0 : IIndex := IRang + INbtours*NBPREM[ IPasse mod ( High( NBPREM )+1 ) ]; // incrmentation selon un Nombre 1er
              1 : IIndex := IRang + INbtours*NBPREM[ IPasse mod ( High( NBPREM )+1 ) ] + IPasse + 1;
              else IIndex := Random( LCelIlot.Count ); // position alatoire
            end;
          // Positionnement cellule
          IIndex := IIndex mod LCelIlot.Count; // recadrage de l'index
          MaCel := GetCel( LCelIlot.Objects[ IIndex ] );
          if MaCel.BTestee then Continue; // cellule dj teste, on coupe court pour passer au tour suivant
          MaCel.BTestee := True;
          Inc( INbTestees );
          // vrif par rapport aux drapeaux existants autour que l'on peut effectivement poser un drapeaux
          BDrapeauOK := True;
          j := 0;
          while BDrapeauOK and ( j < MaCel.LNum.Count ) do
            with MaCel.GetNum( j ) do
              begin
              BDrapeauOK := IEtatV + IDrapeauxAutour  < IEtat;
              Inc( j );
              end;
          if not BDrapeauOK then Continue; // pas de dpot de drapeau permis, on coupe court pour passer au tour suivant...
          // COCHAGE VIRTUEL
          Inc( IDepotV );
          MaCel.IEtatV := ecDrapeau; // dpot du drapeaux virtuel
          IIdSolution := IIdSolution  + NBPREM[ IIndex ]; // somme unique pour marquage solution
          for j := 0 to MaCel.LNum.Count - 1 // incrmention des drapeaux virtuels pour les cellules numrotes voisines
            do Inc( MaCel.GetNum( j ).IEtatV );
          // prochaine cellule de l'ilot a tester
          finally
          Inc( INbTours );
          BSortie := INbTestees = LCelIlot.Count; // toutes les cellules ont t testes
          if not BSortie then
            if ICycle in [ 0, 1 ] then
              if INbTours mod LCelIlot.Count = 0
                then ICycle := 2; // passage en mode Alea, si cellules encore a traiter en mode NBPrems
          end;

        // VALIDATION DE LA SOLUTION TROUVEE par ventilation des cellules cotieres
        // NEttement + rapide qu'une ventilation par cellules d'ilot - c'est la raison d'tre de LCoteIlot

        Result := True;
        for i := 0 to LCelCote.Count - 1 do // pour toutes les cellules de l'ilot
        with GetCel( LCelCote.Objects[ i ] ) do
          if IEtat <> ( IDrapeauxAutour + IEtatV ) then // le numro doit valoir NbDrapeauxExistants+NbDrapeauxVirtuels
            begin
            Result := False;
            Break;
            end;

   end;

   // Pour debug et etudes stats
   procedure Journaliser( ICycle, IPasse: Integer );
   var
     ICpt1, ICpt2, ICpt3 : Integer;
     SLigne: string;
   begin
        if IPAsse >= LJournal.Count then Exit; // mauvaise init du journal
        try
        SLigne := LJournal[ IPasse ];
        ICpt1 := StrToInt( GetShortHint( SLigne ) );
        ICpt2 := StrToInt( GetShortHint( GetLongHint( SLigne ) ) );
        ICpt3 := StrToInt( GetLongHint( GetLongHint( SLigne ) ) );
        case ICycle of
          0 : Inc( ICpt1 );
          1 : Inc( ICpt2 );
          2 : Inc( ICpt3 );
        end;
        LJournal[ IPasse ] := IntToStr( ICpt1 ) + '|' + IntToStr( ICpt2 ) + '|' + IntToStr( ICpt3 );
        except end; // aucune expcetion tolre
   end;

var
   i, j: Integer;
   LDrapeaux: TList; // liste des drapeaux trouvs [indice LCelIlot ]
   IPasse: Integer; //compteur de passe pour le cycle en cours
   ICycle: Integer; // N du cycle (ou stratgie) en cours, 3 cycles, 2 par incrments, 1 par hasard
   TCycle : array[ 0..2 ] of Integer; // nombre de tours pour chaque cycle/stratgie
   IForceDefaut: Integer; // Nbre d'itration par dfaut, meilleur compromis Temps/succs
begin
     // Inits
     LabelRef.Visible := True;
     try
     LCelIlot := TStringList( LIlots.Objects[ IIlot ] );
     LcelCote := TStringList( LCotes.Objects[ IIlot ] );
     if ( LCelIlot.Count = 0 ) or ( LCelCote.Count = 0 ) then Exit; // pas de cellules  traiter
     IMaxDrapeaux := Min( INbMines - ITotalDrapeaux, LCelIlot.Count ); // Nb maxi de drapeaux  poser dans l'ilot
     LIdSolution.Clear;

     // Gestion de la force de calcul
     IForceDefaut := 350;
     case RadioGroupIA.ItemIndex of
       1: IMaxTours := IForceDefaut; // meilleur compromis vitesse - courbes tudies
       2: IMaxTours := 1000; // un peu plus de tours, donne un peu plus de solutions dispo.
       3 : try
           IMaxTours := StrToInt(  EditMaxTours.Text );
           if IMaxTours < 0 then begin IMAxTours := 1; EditMaxTours.Text := '1'; end;
           except EditMaxTours.Text := IntToStr( IForceDefaut ); IMaxTours := IForceDefaut; end;
       else IMaxTours := IForceDefaut;
     end;
     
     // Nombre de cycles idal par EMPIRISME ET ETUDE de courbes statistiques de comptages de solutions
     TCycle[ 0 ] := 55; // tours sur ventilations par incrmentation sur nombre premier -> 75% des solutions
     TCycle[ 1 ] := 90; // alternative au cycle 1
     TCycle[ 2 ] := IMaxTours - TCycle[ 0 ] - TCycle[ 1 ]; // le reste en alatoire

     // Point dedpart
     for ICycle := 0 to 2 do
     for IPasse := 0 to TCycle[ ICycle ]-1 do
       begin
       // Ventilation en prenant comme point de dpart chaque cellule
       for i := 0 to LCelIlot.Count - 1 do
         if UneSolution( i, IPasse, ICycle ) then
           begin
           // Verification solution non trouve
           if LIdSolution.IndexOf( IntToStr( IIdSolution ) ) <> -1
             then Continue; // on zappe, solution dj trouve
           LIdSolution.Add( IntToStr( IIdSolution ) );
           // Ajout de la solution dans la liste des solutions
           LDrapeaux := TList.Create;
           for j := 0 to LCelIlot.Count - 1 do
             if GetCel( LCelIlot.Objects[ j ] ).IEtatV = ecDrapeau
               then LDrapeaux.Add( Pointer( j ) );
           GetSolutions( IIlot ).Add( LDrapeaux );
           Journaliser( ICycle, IPasse ); // pour tude de stats
           end;
       // Reprise de la main
       Application.ProcessMessages;
       if ButtonStop.Tag = 1 then Exit;
       end;

     finally LabelRef.Visible := False; end;
end;


// Rsolutions de tous les ilots en cours
procedure TFMain.ResoudreIlots;
var
   i, j : Integer;
   ISommeDepotV, IMaxV : Integer;
   LFusion: TList; // liste des ilots  fusionner
begin
     // Rsolution de chaque Ilot, 1  1
     DoneSolutions;
     Randomize;
     for i := 0 to LIlots.count - 1 do
       begin
       LIlotSolutions.Add( TList.Create ); // Allocation du pool de solutions pour l'ilot i
       ResoudreIlot( i );
       end;
     // -> LIlotsSolution possde X solution pour chaque ilot


     // Vrification rapide de la cohrence de l'ensemble des ilots
     // Le nbre de drapeaux virtuels total poss doit tre infrieur aux mines restantes... 
     ISommeDepotV := 0;
     LFusion := TList.Create;
     try
     for i := 0 to LIlots.Count - 1 do
       begin
       if GetSolutions( i ).Count = 0 then COntinue; // on zappe si aucune solution sur l'ilot
       IMAxV := GetSolution( i, 0 ).Count;
       for j := 1 to GetSolutions( i ).Count - 1 do
         begin
         if IMaxV <> GetSolution( i, j ).Count then
           if LFusion.IndexOf( Pointer( i ) ) = -1
             then LFusion.Add( Pointer( i ) );
         IMaxV := Max( IMaxV, GetSolution( i, j ).Count );
         end;
       Inc( ISommeDepotV, IMaxV );
       end;

     // Fusion ventuel, si TotalDrapeaux virtuels dpassent capacit mines
     if ISommeDepotV + ITotalDrapeaux > INbMines then
       if LFusion.Count > 1 then
         begin
         FusionnerIlots( LFusion );
         ResoudreIlots; // en principe, 1 cylcle rcursif maxi.
         end;
     finally LFusion.Free; end;
end;

// Rsolution des solutions de chaque ilot
// renvoie True si des cellules sures on pu tre trouves et traites
// False si pas de solutions sur au niveau Ilot ou Drapeaux -> on passe le relai  Go1Tour
function TFMain.TraiterIlots;
var
   i, j, k : Integer;
   LCelIlot: TStringList; // Liste des cellules de l'ilot courant
   INbDrapeauxCellule : Integer; // Comptage de drapeaux par cellule sur l'ensemble des solution
   IIndexCelIlot, IAtraiter : Integer; // Index sur liste
   MaCellule: TCellule; // Cellule courante
   ITaux: Integer;
   INbBombesCotes : Integer; // Total bombes potentiels le long des cotes
   INbCellulesCotes : Integer; // Total des cellules cotieres
begin
     Result := False;
     INbBombesCotes := 0;
     INbCellulesCotes := 0;

     // Rsolution de tous les ilots -> rsultat Dans LIlotSolutions
     ResoudreIlots;


     // Analyse des solutions uniques d'ilot
     for i := 0 to LIlots.Count - 1 do
       begin
       if GetSolutions( i ).Count <> 1 then Continue; // traitement solutions unique uniquement
       LCelIlot := TStringList( LIlots.Objects[ i ] );
       for j := 0 to LCelIlot.Count - 1 do
         if GetSolution( i, 0 ).IndexOf( Pointer( j ) ) = -1 then
           begin
           GetCel( LCelIlot.Objects[ j ] ).CliquerGauche;
           Break;
           end;
       Result := True;
       end;
     if Result then Exit; // validation d'au moins une solution, on en cherche pas d'autres
     

     // Analyse des solutions multiples d'ilot
     for i := 0 to LIlots.Count - 1 do
       begin
       if GetSolutions( i ).Count < 2 then Continue; // Solutions multiples uniquement
       LCelIlot := TStringList( LIlots.Objects[ i ] );

       // Maj des compteurs pour stats finales (taux sur cellules des ilots)
       Inc( INbBombesCotes, GetSolution(i, 0 ).Count ); // bombes potentielles pour 1 cote
       Inc( INbCellulesCotes, LCelIlot.Count ); // Cumul cellules cotieres

       // INIT COMPTEURS de drapeaux par cellule
       for j := 0 to LCelIlot.Count - 1
         do LCelIlot[ j ] := IntToStr( 0 );

       // comptage des drapeaux sur chaque cellule sur toutes les solutions
       for j := 0 to GetSolutions( i ).Count - 1 do
         for k := 0 to GetSolution( i, j ).Count - 1 do
           begin
           IIndexCelIlot := GetDrapeauSolution( i, j, k );
           LCelIlot[ IIndexCelIlot ] := IntToStr( StrToInt( LCelIlot[ IIndexCelIlot ] ) + 1 );
           end;

       // ETUDE DES COMPTEURS DE DRAPEAUX PAR CELLULE
       for j := 0 to LCelIlot.Count - 1 do
         begin
         MaCellule := GetCel( LcelIlot.Objects[ j ] );
         INbDrapeauxCellule :=  StrToInt( LCelIlot[ j ] );

         // DRAPEAUX N'APPARAISSANT JAMAIS -> OK ON DEMINE
         if INbDrapeauxCellule = 0 then
           begin
           MaCellule.CliquerGauche;
           Result := True;
           end
         else

         // DRAPEAUX SYSTEMATIQUEMENT PRESENT -> OK ON POSE UN DRAPEAUX
         if INbDrapeauxCellule = GetSolutions( i ).Count then
           begin
           MaCellule.CliquerDroit( -2 );
           Result := True;
           end
         else

         // SINON, MAJ DES RISQUES DE TROUVER UN DRAPEAUX SUR LA CELLULE
         // pas sur, on calcul le taux de risque sur les cellules de l'ilot
           if CheckBoxRisqueBordure.Checked then
             begin
             IATraiter := LAtraiter.IndexOfObject( TObject( MaCellule.PPos.Y shl 16 + MaCellule.PPos.X ) );
             if IATraiter <> -1 then
               begin
               ITaux := Round( INbDrapeauxCellule / GetSolutions( i ).Count * 100 );
               LAtraiter[ IATraiter ] := SFormatDroite( IntToStr( ITaux ), 3, '0' );
               end;
             end;

         end; // de j



       end; // de i - ilot

       // MAJ DES RISQUES DES CELLULES ISOLEES RESTANTES - CAR LES RISQUES ILOTS ON CHANGE
       if ( not Result ) and CheckBoxRisqueBordure.Checked then
         begin
         if LAtraiter.Count - INbCellulesCotes <> 0 then
           begin
           ITaux := Round( (INbMines - ITotalDrapeaux - INbBombesCotes ) / ( LAtraiter.Count - INbCellulesCotes ) * 100 );
           for i := 0 to LAtraiter.Count - 1 do
             if GetCel( LAtraiter.Objects[ i ] ).LNum.Count = 0
               then LAtraiter[ i ] := SFormatDroite( IntToStr( ITaux ), 3, '0' );
           end;
         LATraiter.Sort; // les taux on changs, on retri la liste
         end;
end;

procedure TFMain.DebugMontrerIlots( BMontrer: Boolean; IIlot: Integer );
var
   i : Integer;
   LCelIlot: TStringList;
   MaCellule : TCellule;
begin
     LCelIlot := TStringList( LIlots.Objects[ IIlot ] );
     for i := 0 to LCelIlot.Count - 1 do
       begin
       MaCellule := GetCel( LCelIlot.Objects[ i ] );
       if BMontrer
         then MaCellule.CliquerDroit( -3 )
         else MaCellule.CliquerDroit( 0 );
       end;
end;


// Montrer une solution de l'ilot (DEBUG)
procedure TFMain.DebugMontrerDrapeaux( IIlot: Integer );
var
   i, j:Integer;
   LCelIlot: TStringList;
begin
     for i := 0 to GetSolutions( IIlot ).Count - 1 do
       begin
       LCelIlot := TStringList( LIlots.Objects[ IILot ] );
       for j := 0 to GetSolution( IIlot, i ).Count - 1
         do GetCel( LCelIlot.Objects[ GetDrapeauSolution( IIlot, i, j ) ] ).CliquerDroit( -3 );
       ShowMessage( 'version n' + IntToStr( i ) );
       for j := 0 to GetSolution( IIlot, i ).Count - 1
         do GetCel( LCelIlot.Objects[ GetDrapeauSolution( IIlot, i, j ) ] ).CliquerDroit( 0 );
       end;
end;

//===============================================================================================
// OUTILS SOLUTIONS D'ILOT
//===============================================================================================
function TFMain.GetSolutions( IIlot: Integer ): TList;
begin
     Result := TList( LIlotSolutions[ Integer( IIlot ) ] );
end;

function TFMain.GetSolution( IIlot, ISolution: Integer): TList;
begin
     Result := TList( GetSolutions( IIlot )[ Integer( ISolution ) ] );
end;

function TFMain.GetDrapeauSolution( IIlot, ISolution, IRang: Integer ): Integer;
begin
     Result := Integer( GetSolution( IIlot, ISolution )[ IRang ] );
end;

// Liste des ilots  fusionner, rsultat dans le 1er ilot de la liste
// dans le cas ou les solutions dpassent le nombre de mines dispo.
procedure TFMain.FusionnerIlots( LFusion: TList );
var
   i, j : Integer;
   IIlot1, IIlot2: Integer;
   LCelIlot1, LCelIlot2: TStringList;
   LCelCote1, LCelCote2: TStringList;
   IIndex : Integer;
begin
     if LFusion.Count < 2 then Exit;

     // Concatnation des ilots dans le 1er
     IIlot1 := Integer( LFusion[ 0 ] );
     LCelIlot1 := TStringList( LIlots.Objects[ IIlot1 ] );
     LCelCote1 := TStringList( LCotes.Objects[ IIlot1 ] );
     for i := 1 to LFusion.Count - 1 do
       begin
       IIlot2 := Integer( LFusion[ i ] );
       LCelIlot2 := TStringList( LIlots.Objects[ IIlot2 ] );
       LCelCote2 := TStringList( LCotes.Objects[ IIlot2 ] );
       for j := 0 to LCelIlot2.Count - 1
         do LCelIlot1.AddObject( LCelIlot2[ j ], LCelIlot2.Objects[ j ] );
       for j := 0 to LCelCote2.Count - 1
         do LCelCote1.AddObject( LCelCote2[ j ], LCelCote2.Objects[ j ] );
       LCelIlot2.Free;
       LCelCote2.Free;
       LIlots[ IIlot2 ] := 'x';
       end;

     // suppression des ilots fusionns
     IIndex := LIlots.IndexOf( 'x' );
     while IIndex <> -1 do
       begin
       LIlots.Delete( IIndex );
       LCotes.Delete( IIndex );
       IIndex := LIlots.IndexOf( 'x' );
       end;

     // Remise  jour de l'affectation Ilot des cellules
     for i := 0 to LIlots.Count - 1 do
       begin
       LCelIlot1 := TStringList( LIlots.Objects[ i ] );
       LCelCote1 := TStringList( LCotes.Objects[ i ] );
       for j := 0 to LCelIlot1.Count - 1
         do GetCel( LCelIlot1.Objects[ j ] ).IIlot := i;
       for j := 0 to LCelCote1.Count - 1
         do GetCel( LCelCote1.Objects[ j ] ).IIlot := i;
       end;
end;

//===============================================================================================
// INTERFACE
//===============================================================================================
procedure TFMain.FormShow(Sender: TObject);
begin
     // mise en forme intiale en dur...
     Width := 430;
     Height := 470;
     if PanelDebug.Visible then Height := Height + PanelDebug.Height;
     if PanelOptions.Visible then Width := Width + PanelOptions.Width;
     Memo.Anchors := [ akLeft, akTop, akBottom ];
     Top := Screen.WorkAreaHeight - Height - 8;
     Left := Screen.WorkAreaWidth - Width - 8;
     // Inits en durs de la grille dmineur
     PixOrigine := Point( 12, 55 ); // en pixels
     CelDim := Point( 16, 16 ); // en pixels
     // Allocations
     LIlots := TStringList.Create;
     LCotes := TStringList.Create;
     LIlotSolutions := TList.Create;
     LAtraiter := TStringList.Create;
     LIdSolution := TStringList.Create;
     LJournal := TStringList.Create; 
     // Inits
     SDemineur := 'c:\windows\system32\winmine.exe';
     if not FileExists( SDemineur )
       then SDemineur := 'winmine.exe';
     // Activations des options
     RadioGroupNiveauClick( nil );
     RadioGroupIAClick( nil );
end;

procedure TFMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Fermer;
     Done1Tour;
     DoneGrille;
     LAtraiter.Free;
     LIlots.Free;
     LIlotSolutions.Free;
     LCotes.Free;
     LIdSolution.Free;
     LJournal.Free;
     try ReleaseDC( HDemineur, HDCDemineur ); except end;
end;

procedure TFMain.ButtonLancerClick(Sender: TObject);
begin
     InitGrille( True );
end;

procedure TFMain.ButtonFermerClick(Sender: TObject);
begin
     DoneGrille;
     Fermer;
end;

procedure TFMain.ButtonStartClick(Sender: TObject);
var
   i : Integer;
   NbParties: Integer;
   NbGagnees : Integer;
   DDebut, DTemps: TDateTime;
   DCumul: TDateTime;
   DCumulGain : TDateTime;
   DMini, DMaxi : TDateTime;
   INbJouees: Integer;
begin
     try
     // Init
     ButtonStart.Enabled := False;
     ButtonStop.Tag := 0;
     DCumul := 0; DCumulGain := 0; DMini := 1; DMaxi := 0;
     NbParties := StrToInt( ComboBoxEditNbParties.text );
     NBGagnees := 0;
     INbJouees := 0;
     for i := 0 to NbParties - 1 do
       begin

       // Rsolution dmineur
       DDebut := Now;
       Go( i = 0 );
       DTemps := Now - DDebut;

       // Reprise du contrle
       Application.ProcessMessages;
       if ButtonStop.Tag = 1 then break;
       Inc( INbJouees );

       // Temps
       DCumul := DCumul + DTemps;
       if Bfini = 1 then
         begin
         DCumulGain := DCumulGain + DTemps;
         DMini := Min( DMini, DTemps );
         DMaxi := Max( DMaxi, DTemps );
         Inc( NbGagnees );
         end;

       // Affichages
       LabelAvancement.Caption := IntToStr( NbGagnees ) + ' / ' + IntToStr( i + 1 );
       if i + 1 <> 0 then
         LabelAvancement.Caption := LabelAvancement.Caption + ' soit ' +
                                    FormatFloat( '0.0', ( NbGagnees / ( i +1 ) * 100 ) ) + '%';

       // Arrets User
       if ( RadioGroupMode.ItemIndex in [ 1, 2 ] ) and ( BFini = 1 ) then
         if (MessageDlg('Partie gagne en ' + FormatDateTime( 's,z', DTemps ) + ' sec.'+#13+#10+'Continue Mode "Arret  chaque gain" ?', mtConfirmation, [mbYes, mbNo], 0) = mrNo)
           then RadioGroupMode.ItemIndex := 0
           else
       else
       if ( RadioGroupMode.ItemIndex = 2 ) then
         if (MessageDlg('Partie perdue en ' + FormatDateTime( 's,z', DTemps ) + ' sec.'+#13+#10+'Continue Mode "Arret  chaque fin de partie" ?', mtConfirmation, [mbYes, mbNo], 0) = mrNo)
           then RadioGroupMode.ItemIndex := 0;

       end;

     //Log
     if ( HDemineur = 0 ) or ( HDCDemineur = 0 ) then
       Memo.Lines.Add( 'ERREUR DE LANCEMENT DU DEMINEUR' )
     else
       begin
       Memo.Lines.Add( '*** niveau ' + RadioGroupNiveau.Items[ RadioGroupNiveau.ItemIndex ] + ' - ' +
                       RadioGroupMethode.Items[ RadioGroupMethode.ItemIndex ] + ' -' +
                       RadioGroupIA.Items[ RadioGroupIA.ItemIndex ] );
       if INbJouees > 0 then
         Memo.Lines.Add( 'Parties gagnes:' + #9 + IntToStr( NbGagnees ) + ' / ' + IntToStr( INbJouees ) +
                         ' (' + FormatFloat( ' 0.##', NbGagnees/INbJouees*100) + '%)' );
       if INbJouees <> 0
         then Memo.Lines.Add( 'Temps total:' + #9 + HeureToChaine( DCumul ) + ' soit ' + HeureToChaine( DCumul/INbJouees ) + ' par partie en moyenne' );
       if NbGagnees > 0 then
         begin
         Memo.Lines.Add('Moyenne gain:' + #9 +HeureToChaine( DCumulGain/NbGagnees ) );
         Memo.Lines.Add('Meilleur Temps: ' + #9 + HeureToChaine( DMini )  );
         Memo.Lines.Add('Moins bon Temps: ' + #9 + HeureToChaine( DMaxi )  );
         end;
       end;
     Memo.Lines.Add( '');
     finally
     ButtonStart.Enabled := True;
     ButtonStop.Tag := 0;
     end;
end;

procedure TFMain.ButtonStopClick(Sender: TObject);
begin
     ButtonStop.Tag := 1;
     BFIni := -1;
     Abort;
end;

procedure TFMain.RadioGroupIAClick(Sender: TObject);
begin
     EditMaxTours.Visible := RadioGroupIA.ItemIndex = 3;
end;

procedure TFMain.RadioGroupNiveauClick(Sender: TObject);
begin
     GroupBoxLibre.Enabled := RadioGroupNiveau.ItemIndex > 2;
     case RadioGroupNiveau.ItemIndex of
       0 : begin
           EditHauteur.Text := '9';
           EditLargeur.Text := '9';
           EditMines.Text := '10';
           end;
       1 : begin
           EditHauteur.Text := '16';
           EditLargeur.Text := '16';
           EditMines.Text := '40';
           end;
       2 : begin
           EditHauteur.Text := '16';
           EditLargeur.Text := '30';
           EditMines.Text := '99';
           end;
       3 : begin
           if not PanelOptions.Visible
             then ButtonOptions.Click;
           EditHauteur.SetFocus;
           end;
     end;
end;

procedure TFMain.EditDimsExit(Sender: TObject);
var
   IHauteur, ILargeur, IMines: Integer;
begin
     // Hauteur
     try IHauteur := StrToInt( EditHauteur.Text ); except IHauteur := 9; end;
     if IHauteur < 9 then IHauteur := 9 else
     if IHauteur > 24 then IHauteur := 24;
     // Largeur
     try ILargeur := StrToInt( EditLargeur.Text ); except ILargeur := 9; end;
     if ILargeur < 9 then ILargeur := 9 else
     if ILargeur > 30 then ILargeur := 30;
     // Nb Mines
     try IMines := StrToInt( EditMines.Text ); except IMines := 10; end;
     if IMines < 10 then IMines := 10 else
     if IMines > ( ILargeur - 1 ) * ( IHauteur - 1 )
       then IMines := ( ILargeur - 1 ) * ( IHauteur - 1 );
     // Reaffecation
     EditHauteur.Text := IntToStr( IHauteur );
     EditLargeur.Text := IntToStr( ILargeur );
     EditMines.Text := IntToStr( IMines );
end;

procedure TFMain.ImageLogoClick(Sender: TObject);
var
   H: Integer;
begin
     H := Height;
     PanelDebug.Visible := not PanelDebug.Visible;
     if PanelDebug.Visible
       then Height := H + PanelDebug.Height
       else Height := H - PanelDebug.Height;
     if Top + Height > Screen.WorkAreaHeight
       then Top := Screen.WorkAreaHeight - Height - 8;
end;

procedure TFMain.ButtonOptionsClick(Sender: TObject);
var
   W : Integer;
begin
     W :=  PanelMain.Width + 8;
     PanelOptions.Visible := not PanelOptions.Visible;
     if PanelOptions.Visible
       then Width := W + PanelOptions.Width
       else Width := W;
     if PanelOptions.Visible
       then ButtonOptions.Caption := '<<< Options'
       else ButtonOptions.Caption := 'Options >>>';
     if Left + Width > Screen.WorkAreaWidth
       then Left := Screen.WorkAreaWidth - width - 8;
end;

//===============================================================================================
// INTERFACE DEBUG
//===============================================================================================
procedure TFMain.ComboBoxEditNbPartiesKeyDown(Sender: TObject;  var Key: Word; Shift: TShiftState);
begin
     if Trim( UpperCase( ComboBoxEditNbParties.Text ) ) = 'DVP' then
       begin
       ComboBoxEditNbParties.Text := '100';
       ImageLogo.OnClick := ImageLogoClick;
       ShowMessage( 'Mode DEBUG dbloqu' + #13 + 'Cliquer sur la bombe' );
       end;
end;

procedure TFMain.ButtonDebugEtatCelClick(Sender: TObject);
var
   x, y: Integer;
begin
     x := StrToInt( EditX.text );
     y := StrToInt( EditY.text );
     GetCel( x, y ).DebugInfo;

end;

procedure TFMain.ButtonDebugCouleurCelClick(Sender: TObject);
var
   x, y:Integer;
   Couleur: Integer;
begin
     x := StrToInt( EditX.text );
     y := StrToInt( EditY.text );

     with GetCel( x, y ) do
       begin
       x := PPos.X  * CelDim.X + PixOrigine.X;
       y := PPos.Y  * CelDim.Y + PixOrigine.Y;
       Couleur := GetPixel( HDCDemineur, x + CelDim.X div 2, y + CelDim.Y div 2 );
       ShowMessage( 'R=' + IntToStr( GetRValue( Couleur ) ) + #13 +
                    'G=' + IntToStr( GetGValue( Couleur ) ) + #13 +
                    'B=' + IntToStr( GetBValue( Couleur ) ) );
       end;
end;


procedure TFMain.ButtonDebugMajGrilleClick(Sender: TObject);
begin
     MajGrille( True );
end;

procedure TFMain.ListBoxLATraiterDblClick(Sender: TObject);
var
   SLigne: string;
   x, y:Integer;
begin
     SLigne := Copy( ListBoxLAtraiter.Items[ ListBoxLAtraiter.ItemIndex ], 7, 255 );
     SLigne := stringReplace( SLigne, '(', '', [ rfReplaceAll ] );
     SLigne := stringReplace( SLigne, ')', '', [ rfReplaceAll ] );
     SLigne := stringReplace( SLigne, ' ', '', [ rfReplaceAll ] );
     SLigne := stringReplace( SLigne, ',', '|', [ rfReplaceAll ] );
     x := StrToInt( GetShortHint( SLigne ) );
     y := StrToInt( GetLongHint( SLigne ) );                                           
     GetCel( x, y ).CliquerDroit;
     EditX.Text := IntToStr( x );
     EditY.Text := IntToStr( y );
end;

procedure TFMain.ButtonDebugGo1TourClick(Sender: TObject);
begin
     if HDemineur = 0 then InitGrille( True );
     Go1Tour;
     MajGrille;
end;

procedure TFMain.ButtonDebugCreerIlotsClick(Sender: TObject);
var
   i, j : Integer;
   LCelCote: TStringList;
begin
     MajGrille;
     CreerIlots;
     for i := 0 to LIlots.Count - 1 do
       begin
       DebugMontrerIlots( True, i );
       LCelCote := TStringList( LCotes.Objects[ i ] );
       for j := 0 to LcelCote.Count - 1 do GetCel( LCelCote.Objects[ j ] ).DebugCocher( 0 );
       ShowMessage( 'ilot n' + IntToStr( i ) + ' : ' + IntToStr( TStringList( LIlots.Objects[ i ] ).Count )  + #13 +
                    'cote n' + IntToStr( i ) + ' : ' + IntToStr( TStringList( LCotes.Objects[ i ] ).Count ));
       DebugMontrerIlots( False, i );
       end;
     // pour redessiner le dmineur :( - a la place d'un repaint HDC du dmineur
     // refresh, pour liminer le dessin des croix ventuel pour MajGRille correcte
     //Self.WindowState := wsMaximized;
     //Self.WindowState := wsNOrmal;

end;

procedure TFMain.ButtonDebugResoudreIlotsClick(Sender: TObject);
var
   i, j: Integer;
begin
     ResoudreIlots;

     ListBoxLSolutions.Clear;
     for i := 0 to LIlots.COunt - 1 do
       for j := 0 to GetSolutions( i ).Count - 1
         do ListBoxLSolutions.AddItem( ' ' + IntToStr( i ) + ' | ' +
            IntToStr( GetSolution( i, j ).Count ), GetSolution( i, j ) );

     LabelNbListesDrapeaux.Caption := IntToStr( ListBoxLSolutions.Items.Count ) + ' solutions';

end;

procedure TFMain.ListBoxLSolutionsClick(Sender: TObject);
var
   i : Integer;
   IIlot : Integer;
   LCelIlot: TStringList;
   LDrapeaux: TList;
   ILigne: Integer;
begin
     ILigne := ListBoxLSolutions.ItemIndex;
     if ( ILigne < 0 ) or ( ILigne >= ListBoxLSolutions.Count ) then Exit ;
     ListBoxLSolutionsExit( nil );
     IIlot := StrToint( Trim( GetShortHint( ListBoxLSolutions.Items[ ILigne ] ) ) );
     LCelIlot := TStringList( LIlots.Objects[ IIlot ] );
     LDrapeaux := TList( ListBoxLSolutions.Items.Objects[ ILigne ] );

     for i := 0 to LDrapeaux.Count - 1
       do GetCel( LcelIlot, LDrapeaux, i ).Cliquerdroit( -3 );
end;

procedure TFMain.ListBoxLSolutionsExit(Sender: TObject);
var
   x, y: Integer;
begin
     for y := 0 to GrilleDim.Y - 1 do
         for x := 0 to GrilleDim.X - 1 do
         with GetCel( x, y ) do
           begin
           MajEtat;
           if IEtat = ecPtInt
             then CliquerDroit( 0 );
           end;
end;

procedure TFMain.ButtonInitJournalClick(Sender: TObject);
var
   i : Integer;
begin
     LJournal.Clear;
     for i := 0 to 200 do LJournal.Add( '0|0|0' ); // 201 1eres valeurs 
end;

procedure TFMain.ButtonCopierJournalClick(Sender: TObject);
begin
     // pour collage dans Excel
     LJournal.Insert( 0, 'Cycle 0|Cycle1|Cycle2' );
     Clipboard.AsText := StringReplace( LJournal.Text, '|', #9, [ rfReplaceAll ] );
end;


end.



